# $Id: Parser.pm 71 2008-08-31 05:58:17Z jabra $
package Geo::WeatherACCU;
{
    use Object::InsideOut;
    use XML::RSS::Parser;
    use Carp qw(carp);
    my @zipcode : Field : Arg(zipcode) : Get(zipcode);
    my @current : Field : Arg(current) : All(current);
    
    sub get_zipcode {
        my ($self) = @_;
        return $self->zipcode;
    }   

    sub get_current {
        my ($self) = @_;
        return $self->current;
    }   

    sub execute {
        my ($self) = @_;
        if ( ! defined($self->zipcode) or ($self->zipcode !~ /\d{1,5}/) ) {
            carp "Errror: zipcode input error\n";
        }
        my $p = XML::RSS::Parser->new;
        my $feed = $p->parse_uri("http://rss.accuweather.com/rss/liveweather_rss.asp?metric=0&locCode=" . $self->zipcode);

        my $c = $feed->query('//item')->query('title')->text_content;
        if ( defined($c) )  { 
            $self->current($c);
        }
        else {
            carp "Error: current weather not defined\n";
        }
    }
}
1;

